-----------------------------------
-- MOD: GreenhouseInfo           --
-- MOD Version: 1.0              --
-- MOD Author: RedBoxSW          --
-- MOD Date: 18.11.2014          --
--                               --
-- Copyright (C) RedBox Software --
-----------------------------------

GreenhouseInfo = {};
GreenhouseInfo.moddir=g_currentModDirectory;

function GreenhouseInfo:loadMap(name)
self.Overlay = {};
self.Overlay.OverlayId = {};
self.Overlay.OverlayId.ovid = createImageOverlay(Utils.getFilename("Overlay.dds", GreenhouseInfo.moddir));
	self.boolShow = 1;
	Lines = 0;
end;

function GreenhouseInfo:deleteMap()
end;

function GreenhouseInfo:mouseEvent(posX, posY, isDown, isUp, button)
end;

function GreenhouseInfo:keyEvent(unicode, sym, modifier, isDown)
	if isDown and sym == Input.KEY_l and bitAND(modifier, Input.MOD_CTRL) > 0 then
		if self.boolShow == 0 then 
			self.boolShow = 1;
		else
			self.boolShow = 0;
		end;
	end;
end;

function GreenhouseInfo:update(dt)
end;

function GreenhouseInfo:draw()
	if self.boolShow == 0 then return true; end;
	
	local olPosX = g_currentMission.weatherTimeBackgroundOverlay.x; --0.806771;
	local olSizeX = 1.0003 - olPosX;
	local olSizeY = 0.0129 * Lines + 0.002;
	local olPosY = 0.907407 - olSizeY;
	
	renderOverlay(self.Overlay.OverlayId.ovid, olPosX, olPosY, olSizeX, olSizeY);
	
	if Input.keyPressedState[308] then
		return true;
	else
		local fontPosX = olPosX + 0.01;
		local fontPosY = 0.905;
		local fontSize = 0.011;
		local fontLineSize = fontSize + 0.0019;
		setTextAlignment(RenderText.ALIGN_LEFT);
		
		--local tableSize = tablelength(g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"]);

		local greenhouseCaption = "";
		local greenhouseManureValue = "";
		local greenhouseManurePerc = "";
		local greenhouseManureCapacity = 3000;
		local greenhouseWaterValue = "";
		local greenhouseWaterPerc = "";
		local greenhouseWaterCapacity = 2000;
		local greenhouseManureCaption = g_i18n:getText("filltype_manure");
		local greenhouseWaterCaption = g_i18n:getText("filltype_water");

		setTextBold(true);
		setTextColor(0,0,0,1);
		
		tablename = {};
		tablepos = 1;
		count = 0;
		
		Lines = 1;
		
		renderText(fontPosX, fontPosY-(Lines*fontLineSize), fontSize, g_i18n:getText("greenhouses")..":");
		renderText(fontPosX+0.07, fontPosY-(Lines*fontLineSize), fontSize, greenhouseWaterCaption..":");
		setTextColor(1,1,1,1);
		renderText(fontPosX+0.12, fontPosY-(Lines*fontLineSize), fontSize, greenhouseManureCaption..":");
		
		Lines = Lines + 1;
				
		if g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"] ~= nil then readTable(g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"]); end;
		
		if count > 1 then
			for x = 1, count, 1 do
				if g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"][tablename[x]].manureCapacity ~= nil then
					greenhouseCaption = g_i18n:getText("lettuce")..":";
					greenhouseWaterValue = round(g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"][tablename[x]].waterTankFillLevel);
					greenhouseWaterPerc = round(100 / g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"][tablename[x]].waterTankCapacity * greenhouseWaterValue);
					greenhouseManureValue = round(g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"][tablename[x]].manureFillLevel);
					greenhouseManurePerc = round(100 / g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"][tablename[x]].manureCapacity * greenhouseManureValue);
					
					setTextColor(0,0,0,1);
					setTextAlignment(RenderText.ALIGN_RIGHT);
					renderText(fontPosX+0.051, fontPosY-(Lines*fontLineSize), fontSize, greenhouseCaption);
					setTextAlignment(RenderText.ALIGN_LEFT);
					if greenhouseWaterPerc <= 5 then
						setTextColor(1,0,0,1);
					elseif greenhouseWaterPerc > 5 and greenhouseWaterPerc < 16 then
						setTextColor(0.8,0.8,0,1);
					else
						setTextColor(0,0,0,1);
					end;
					renderText(fontPosX+0.07, fontPosY-(Lines*fontLineSize), fontSize, greenhouseWaterValue.."L ("..greenhouseWaterPerc.."%)");
					if greenhouseManurePerc <= 5 then
						setTextColor(1,0,0,1);
					elseif greenhouseManurePerc > 5 and greenhouseManurePerc < 16 then
						setTextColor(0.8,0.8,0,1);
					else
						setTextColor(1,1,1,1);
					end;
					renderText(fontPosX+0.12, fontPosY-(Lines*fontLineSize), fontSize, greenhouseManureValue.."L ("..greenhouseManurePerc.."%)");
					
					Lines = Lines + 1;
				end;
			end;
		
		elseif count == 1 then
			if g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"][tablename[1]].manureCapacity ~= nil then
				greenhouseCaption = g_i18n:getText("lettuce")..":";
					greenhouseWaterValue = round(g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"][tablename[1]].waterTankFillLevel);
					greenhouseWaterPerc = round(100 / g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"][tablename[1]].waterTankCapacity * greenhouseWaterValue);
					greenhouseManureValue = round(g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"][tablename[1]].manureFillLevel);
					greenhouseManurePerc = round(100 / g_currentMission.placeables["data/placeables/greenhouses/greenhouse02.xml"][tablename[1]].manureCapacity * greenhouseManureValue);
					
					setTextColor(0,0,0,1);
					setTextAlignment(RenderText.ALIGN_RIGHT);
					renderText(fontPosX+0.051, fontPosY-(Lines*fontLineSize), fontSize, greenhouseCaption);
					setTextAlignment(RenderText.ALIGN_LEFT);
					if greenhouseWaterPerc <= 5 then
						setTextColor(1,0,0,1);
					elseif greenhouseWaterPerc > 5 and greenhouseWaterPerc < 16 then
						setTextColor(0.8,0.8,0,1);
					else
						setTextColor(0,0,0,1);
					end;
					renderText(fontPosX+0.07, fontPosY-(Lines*fontLineSize), fontSize, greenhouseWaterValue.."L ("..greenhouseWaterPerc.."%)");
					if greenhouseManurePerc <= 5 then
						setTextColor(1,0,0,1);
					elseif greenhouseManurePerc > 5 and greenhouseManurePerc < 16 then
						setTextColor(0.8,0.8,0,1);
					else
						setTextColor(1,1,1,1);
					end;
					renderText(fontPosX+0.12, fontPosY-(Lines*fontLineSize), fontSize, greenhouseManureValue.."L ("..greenhouseManurePerc.."%)");
				
				Lines = Lines + 1;
			end;
		end;
		
		tablename = {};
		tablepos = 1;
		count = 0;
		
		if g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"] ~= nil then readTable(g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"]); end;
		
		if count > 1 then
			for y = 1, count, 1 do
				if g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"][tablename[y]].manureCapacity ~= nil then
					greenhouseCaption = g_i18n:getText("tomatoes")..":";
					greenhouseWaterValue = round(g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"][tablename[y]].waterTankFillLevel);
					greenhouseWaterPerc = round(100 / g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"][tablename[y]].waterTankCapacity * greenhouseWaterValue);
					greenhouseManureValue = round(g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"][tablename[y]].manureFillLevel);
					greenhouseManurePerc = round(100 / g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"][tablename[y]].manureCapacity * greenhouseManureValue);
					
					setTextColor(0,0,0,1);
					setTextAlignment(RenderText.ALIGN_RIGHT);
					renderText(fontPosX+0.051, fontPosY-(Lines*fontLineSize), fontSize, greenhouseCaption);
					setTextAlignment(RenderText.ALIGN_LEFT);
					if greenhouseWaterPerc <= 5 then
						setTextColor(1,0,0,1);
					elseif greenhouseWaterPerc > 5 and greenhouseWaterPerc < 16 then
						setTextColor(0.8,0.8,0,1);
					else
						setTextColor(0,0,0,1);
					end;
					renderText(fontPosX+0.07, fontPosY-(Lines*fontLineSize), fontSize, greenhouseWaterValue.."L ("..greenhouseWaterPerc.."%)");
					if greenhouseManurePerc <= 5 then
						setTextColor(1,0,0,1);
					elseif greenhouseManurePerc > 5 and greenhouseManurePerc < 16 then
						setTextColor(0.8,0.8,0,1);
					else
						setTextColor(1,1,1,1);
					end;
					renderText(fontPosX+0.12, fontPosY-(Lines*fontLineSize), fontSize, greenhouseManureValue.."L ("..greenhouseManurePerc.."%)");
					
					Lines = Lines + 1;
				end;
			end;
		
		elseif count == 1 then
			if g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"][tablename[1]].manureCapacity ~= nil then
				greenhouseCaption = g_i18n:getText("tomatoes")..":";
					greenhouseWaterValue = round(g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"][tablename[1]].waterTankFillLevel);
					greenhouseWaterPerc = round(100 / g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"][tablename[1]].waterTankCapacity * greenhouseWaterValue);
					greenhouseManureValue = round(g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"][tablename[1]].manureFillLevel);
					greenhouseManurePerc = round(100 / g_currentMission.placeables["data/placeables/greenhouses/greenhouse01.xml"][tablename[1]].manureCapacity * greenhouseManureValue);
					
					setTextColor(0,0,0,1);
					setTextAlignment(RenderText.ALIGN_RIGHT);
					renderText(fontPosX+0.051, fontPosY-(Lines*fontLineSize), fontSize, greenhouseCaption);
					setTextAlignment(RenderText.ALIGN_LEFT);
					if greenhouseWaterPerc <= 5 then
						setTextColor(1,0,0,1);
					elseif greenhouseWaterPerc > 5 and greenhouseWaterPerc < 16 then
						setTextColor(0.8,0.8,0,1);
					else
						setTextColor(0,0,0,1);
					end;
					renderText(fontPosX+0.07, fontPosY-(Lines*fontLineSize), fontSize, greenhouseWaterValue.."L ("..greenhouseWaterPerc.."%)");
					if greenhouseManurePerc <= 5 then
						setTextColor(1,0,0,1);
					elseif greenhouseManurePerc > 5 and greenhouseManurePerc < 16 then
						setTextColor(0.8,0.8,0,1);
					else
						setTextColor(1,1,1,1);
					end;
					renderText(fontPosX+0.12, fontPosY-(Lines*fontLineSize), fontSize, greenhouseManureValue.."L ("..greenhouseManurePerc.."%)");
				
				Lines = Lines + 1;
			end;
		end;

	end;
	
end;

-- ------------------------------------------------------------------------------------------------- --

function round(num, idp)
	if Utils.getNoNil(num, 0) > 0 then
		local mult = 10^(idp or 0);
		return math.floor(num * mult + 0.5) / mult;
	else 
		return 0;
	end;
end;

function readTable(j)
   for k, v in pairs(j) do
       if type(j[k]) == "table" then
	   tablename[tablepos] = k;
	   tablepos = tablepos + 1;
	   count = count + 1;
       end;
      --count = math.max(1, count-1)
   end;
end;

function tablelength(T)
  for _ in pairs(T) do count = count + 1 end;
  return count;
end;

addModEventListener(GreenhouseInfo);